#include <libce.h>
#include <apic.h>

const ioaddr iSTR = 0x64;
const ioaddr iRBR = 0x60;
const ioaddr iCMD = 0x64;
const ioaddr iTBR = 0x60;

void abilita_intr()
{
	outputb(0x60, iCMD);
	outputb(0x61, iTBR);
}

void disabilita_intr()
{
	outputb(0x60, iCMD);
	outputb(0x61, iTBR);
}

bool volatile fine = false;

extern "C" void a_driver();
extern "C" void c_driver()
{
	natb c;
	inputb(iRBR, c);
	if (c == 0x01)	// make code di ESC
		fine = true;
	for (int i = 0; i < 8; i++) {
		char_write('0' + !!(c & 0x80));
		for (volatile int j = 0; j < 5000000; j++)
			;
		c <<= 1;
	}
	char_write('\n');
	apic_send_EOI();
}

extern natw* video;
extern natb attr;


const int KBD_TYPE =  0x40;

int main()
{
	unsigned int spinpos = 0;
	char spinner[] = { '|', '/', '-', '\\' };

	clear_screen(0x0f);
	apic_set_VECT(1, KBD_TYPE);
	gate_init(KBD_TYPE, a_driver);
	apic_set_MIRQ(1, false);
	abilita_intr();

	while (!fine) {
		video[12*80+40] = (attr << 8) | spinner[spinpos % 4];
		spinpos++;
	}
	return 0;
}
